﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
//using CityNetworks.Reconciliations.Common.Client;
using Infragistics.Windows.Controls;
using Infragistics.Windows;


namespace CityNetworks.Reconciliations.Wpf.Controls
{
    /// <summary>
    /// Interaction logic for BizUnitControl.xaml
    /// </summary>
    public partial class BizUnitControl : UserControl
    {
        ToolWindow window = new ToolWindow();
        public BizUnitControl()
        {
            InitializeComponent();
            Image image = new Image();
            image.Source = new BitmapImage(new Uri("http://localhost/I6Base/images/Drill.png"));
            this.BizUnitDrillImage.Content = image;
            System.Windows.Controls.TreeView tv = new TreeView();
            
            TreeViewItem tvI = new TreeViewItem();
            TreeViewItem tvI1 = new TreeViewItem();
            tvI.IsExpanded = true;
            tvI.Header = GetNodeTemplate("Test");
            tv.Items.Add(tvI);
            tvI.Items.Add(tvI1);
            tvI1.Header = GetNodeTemplate("Test1");
            window.Content = tv;
            window.UseOSNonClientArea = false;
            window.ResizeMode = ResizeMode.CanResizeWithGrip;
            window.BorderThickness = new Thickness(1);
            window.AllowClose = true;
            tv.SelectedItemChanged += new RoutedPropertyChangedEventHandler<object>(tv_SelectedItemChanged);
            tvI.KeyUp += new KeyEventHandler(tvI_KeyUp);
            tv.KeyUp += new System.Windows.Input.KeyEventHandler(tv_KeyUp);
        }
        private StackPanel GetNodeTemplate(string displayText)
        {
            StackPanel nodeItem = new StackPanel();
            nodeItem.Orientation = Orientation.Horizontal;
            Image itemImage = new Image();
            itemImage.Source = new BitmapImage(new Uri("http://localhost/I6Base/images/SearchFolder.png"));
            itemImage.Height = double.Parse("20");
            itemImage.Width = double.Parse("20");
            nodeItem.Children.Add(itemImage);
            Label lbl = new Label();
            lbl.Content = displayText;
            nodeItem.Children.Add(lbl);
            return nodeItem;
        }
        void tv_KeyUp(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                window.Close();
            }
        }

        void tvI_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Enter)
            {
                window.Close();
            }
        }

        void tv_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            if (e != null && e.NewValue is TreeViewItem)
            {
                this.BizUnitNameBox.Text = ((Label)((StackPanel)((TreeViewItem)e.NewValue).Header).Children[1]).Content.ToString();
            }
        }

        private void BizUnitDrillImage_Click(object sender, RoutedEventArgs e)
        {
            
            Point pt= Utilities.PointToScreenSafe(this, new Point());
            window.Top = pt.Y+30;
            window.Left = pt.X;
            window.Width = this.BizUnitNameBox.ActualWidth;
            window.ShowDialog(this, new ToolWindow.ShowDialogCallback(OnBizUnitDropDownClosed));
        }

        private void OnBizUnitDropDownClosed(ToolWindow toolWindow, bool? dialogResult)
        {
            toolWindow.Resources = null;
            
        }

        private void BizUnitNameBox_KeyUp(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Down)
            {
                Point pt = Utilities.PointToScreenSafe(this, new Point());
                window.Top = pt.Y + 30;
                window.Left = pt.X;
                window.ShowDialog(this, new ToolWindow.ShowDialogCallback(OnBizUnitDropDownClosed));
            }
        }
    }
}
